; Escape  v0.11 - version spciale pour le concours de tiprogs.free.fr
; par pacHa [ pacha-@wanadoo.fr ]

; La source est un peu en bordel, alors bonne chance :p
; Les commentaires sont en anglais et en franais :(


; 82 version
.include	acebeta.inc


; 83 version--------------
;#define SH_BUF saferam2
;#define HL_DECI hl_deci83
;#define TI83
;.include	vion.inc
;.include	82to83.inc
;.org	$9329
;.db	"9_[V?",1
;	jr	nc,start
; ------------------------


.db	$cd,"Escape!",6,"v0.11",0


#define	Xmax	68
#define	Ymax	59
#define	start_lives	20

#define	rand	GET_RAND

score             =        SH_BUF
timer             =        SH_BUF + 2
number_of_balls   =        SH_BUF + 3
_time             =        SH_BUF + 4
cursorX           =        SH_BUF + 5
cursorY           =        SH_BUF + 6
lives             =        SH_BUF + 7
dead              =        SH_BUF + 8
balls             =        SH_BUF + 9 ; data pour les balles. structure : x-coord, y-coord, right-flag, down-flag
                                      ; (4 bytes / ball)
freespace         =        SH_BUF + 200

start:

	set	7,(iy+$14)		; write menu text in GRAPH_MEM

	;di	; gagne un peu plus de vitesse :p

#ifdef TI83
	call	_grbufclr
#endif

	ld	hl,title
	ld	de,GRAPH_MEM + 83
	ld	bc,520
	ldir
	ld	hl,$3910
	ld	(GRAF_CURS),hl
	ld	hl,txt_highscore
	CALL	D_ZM_STR
	ld	hl,highscore
	CALL	LD_HL_MHL
	CALL	HL_DECI
	CALL	D_ZM_STR
	CALL	CR_GRBCopy
#ifdef TI83
	call	_getkey
#else
	CALL	GET_KEY
	or	a
	jr	z,$-4
#endif

#ifdef TI83
	call	_grbufclr
	ld	hl,SH_BUF
	ld	de,SH_BUF + 1
	ld	(hl),0
	ld	bc,528
	ldir
#else
	xor	a
	ld	bc,768
	ld	hl,GRAPH_MEM
	CALL	FILL
	ld	bc,1999
	ld	hl,SH_BUF
	CALL	FILL
#endif

	ld	hl,timer
	ld	(hl),$ff

	ld	hl,cursorX
	ld	(hl),Xmax / 2 - 2
	inc	hl
	ld	(hl),Ymax / 2 - 2
	inc	hl
	ld	(hl),start_lives

	ld	hl,balls
	ld	(hl),20		; put 1 ball at (20,20)
	inc	hl
	ld	(hl),20
	inc	hl
	ld	(hl),$ff
	inc	hl
	ld	(hl),$ff

	ld	a,20
	ld	e,a
	call	ball_sprite

	;ld	a,Ymax / 2 - 2
	;ld	e,a
	;ld	a,Xmax / 2 - 2
	;ld	d,5
	;ld	bc,cursor
	;call	cursor_sprite

	ld	hl,GRAPH_MEM + 9		; draw the vertical line
	ld	a,%01000000
	ld	b,64
	ld	(hl),a
	ld	de,12
	add	hl,de
	djnz	$-6

	ld	hl,$004b
	ld	(GRAF_CURS),hl
	ld	hl,txt_score
	CALL	D_ZM_STR

	ld	hl,$104b
	ld	(GRAF_CURS),hl
	ld	hl,txt_time
	CALL	D_ZM_STR

	ld	hl,$204b
	ld	(GRAF_CURS),hl
	ld	hl,txt_balls
	CALL	D_ZM_STR

	ld	hl,$304b
	ld	(GRAF_CURS),hl
	ld	hl,txt_lives
	CALL	D_ZM_STR

	ld	a,(lives)
	ld	l,a
	ld	h,0
	CALL	HL_DECI
	ld	de,$374b
	ld	(GRAF_CURS),de
	CALL	D_ZM_STR
	CALL	CR_GRBCopy


loop:


	CALL	DIRECT_KEY
	push	af
	bit	0,a
	call	z,_up_
	pop	af
	push	af
	bit	1,a
	call	z,_left_
	pop	af
	push	af
	bit	2,a
	call	z,_right_
	pop	af
	push	af
	bit	3,a
	call	z,_down_
	pop	af
	push	af
	bit	6,a
	call	nz,PAUSE
	pop	af
	bit	7,a
	ret	nz
	
	ld	a,(cursorX)
	ld	b,a
	ld	a,(cursorY)
	ld	c,a
	call	check
	inc	b \ inc b \ inc b \ inc b
	call	check	
	inc	c \ inc c \ inc c \ inc c
	call	check
	dec	b \ dec b \ dec b \ dec b
	call	check
	

_after_keys:

	ld	a,(lives)
	cp	$ff
	jp	nc,the_end

	ld	hl,_time
	inc	(hl)

	ld	a,(_time)
	and	%00000001
	jr	z,__afterdisp
	ld	a,(timer)
	dec	a
	push	af
	call	z,newball
	pop	af
	ld	(timer),a
	ld	h,0
	ld	l,a
	ld	de,$174b
	ld	(GRAF_CURS),de
	CALL	HL_DECI
	CALL	D_ZM_STR
	ld	hl,txt_blank
	CALL	D_ZM_STR
__afterdisp:
	ld	a,(_time)
	and	%00001111			; increase score each 8 frames
	jr	nz,___afterdisp
	ld	hl,score
	CALL	LD_HL_MHL
	inc	hl
	ld	(score),hl
	ld	de,$74b
	ld	(GRAF_CURS),de
	CALL	HL_DECI
	CALL	D_ZM_STR

___afterdisp:
	ld	hl,balls
	ld	a,(hl)
	or	a
	jr	z,after
	push	hl
	call	move_and_put
	pop	hl
	inc	hl
	inc	hl
	inc	hl
	inc	hl
	jr	$-13

after:
	call	erase_cursor
	CALL	CR_GRBCopy
	call	erase_cursor

	jp	loop




move_and_put:
	push	hl
	inc	hl
	call	ball_sprite1
	pop	hl


	ld	a,(hl)					; don't go out!
	cp	Xmax
	call	z,change_flag
	dec	a				; cp 1
	call	z,change_flag
	inc	hl
	ld	a,(hl)
	cp	Ymax
	call	z,change_flag
	dec	a				; cp 1
	call	z,change_flag


	inc	hl				; 1st flag
	ld	a,(hl)
	push	af
	dec	hl
	dec	hl
	pop	af
	or	a
	jr	z,$+4
	inc	(hl)
	inc	(hl)
	dec	(hl)

	inc	hl
	inc	hl
	inc	hl				; 2nd flag
	ld	a,(hl)
	push	af
	dec	hl
	dec	hl
	pop	af
	or	a
	jr	z,$+4
	inc	(hl)
	inc	(hl)
	dec	(hl)



	ld	a,(hl)		; put sprite
	ld	e,a
	jp	ball_sprite1

	
change_flag:
	inc	hl
	inc	hl
	ld	a,(hl)
	cpl						; switch $00 <=> $ff
	ld	(hl),a
	dec	hl
	dec	hl
	ret

newball:
	ld	hl,balls
	ld	a,(hl)
	or	a
	jr	z,$+8
	inc	hl
	inc	hl
	inc	hl
	inc	hl
	jr	$-8
	push	hl
	call	rand \ and %00011111 \ inc a \ inc a \ pop hl
	ld	(hl),a
	inc	hl \ push hl
	call	rand \ and %00011111 \ inc a \ inc a \ pop hl
	ld	(hl),a \ push hl
	inc	hl
	ld	(hl),$ff
	inc	hl
	ld	(hl),$ff

	ld	hl,number_of_balls
	inc	(hl)
	ld	a,(hl)
	inc	a
	ld	l,a
	ld	h,0
	ld	de,$274b
	ld	(GRAF_CURS),de
	CALL	HL_DECI
	CALL	D_ZM_STR

	pop	hl
	jp	ball_sprite1

_down_:
	;call	erase_cursor
	ld	a,(cursorY)
	cp	Ymax
		ret	z
	;jr	z,erase_cursor
	inc	a
	ld	(cursorY),a
	;jr	erase_cursor
		ret

_up_:
	;call	erase_cursor
	ld	a,(cursorY)
	dec	a
	cp	1
	ret	z	;jr	z,erase_cursor
	ld	(cursorY),a
	ret		;jr	erase_cursor

_left_:
	;call	erase_cursor
	ld	a,(cursorX)
	inc	a
	cp	Xmax
	ret	z	;jr	z,erase_cursor
	ld	(cursorX),a
	ret		;jr	erase_cursor

_right_:
	;call	erase_cursor
	ld	a,(cursorX)
	dec	a
	cp	1
	ret	z	;jr	z,erase_cursor
	ld	(cursorX),a
	ret		;jr	erase_cursor

erase_cursor:
	ld	bc,cursor
	ld	a,(_time)
	and	%00010000
	jr	z,_erase_cursor
	ld	bc,cursor2
_erase_cursor:
	ld	a,(cursorY)
	ld	e,a
	ld	a,(cursorX)
	;ld	d,5
	jp	cursor_sprite

check:
	call	GetPixel \ ret z
decrease_lives:
	ld	a,(lives)
	dec	a
	ld	(lives),a
	ld	l,a
	ld	h,0
	ld	de,$374b
	ld	(GRAF_CURS),de
	CALL	HL_DECI
	CALL	D_ZM_STR
	ld	hl,txt_blank
	CALL	D_ZM_STR
	call	invert_screen
	CALL	CR_GRBCopy	; wait !
	CALL	CR_GRBCopy	;

invert_screen:
	ld	hl,GRAPH_MEM
	ld	a,(hl)
	cpl
	ld	(hl),a
	ld	de,GRAPH_MEM + 767
	CALL	CP_HL_DE
	jp	z,CR_GRBCopy
	inc	hl
	jr	$-13


the_end:
	CALL	CLEARLCD
	ld	hl,score
	CALL	LD_HL_MHL
	ex	de,hl
	ld	hl,highscore
	CALL	LD_HL_MHL
	CALL	CP_HL_DE
	jr	nc,no_high_score
	ld	hl,highscore
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,txt_new_highscore
	ld	de,$50a
	ld	(GRAF_CURS),de
	CALL	D_ZM_STR
no_high_score:
	CALL	CR_GRBCopy
	CALL	PAUSE
#ifndef TI83
	ld	hl,GRAPH_MEM
	ld	(hl),$ff
	ld	de,GRAPH_MEM + 1
	ld	bc,767
_ldi_loop:
	ldi
	ldi
	ret	po
	ldi
	push	hl
	CALL	CR_GRBCopy
	pop	hl
	jr	_ldi_loop
#else
	ret
#endif

ball:
	.db	%01110000
	.db	%11101000
	.db	%11111000
	.db	%11111000
	.db	%01110000

cursor:
	.db	%00100000
	.db	%00100000
	.db	%11011000
	.db	%00100000
	.db	%00100000

cursor2:
	.db	%00000000
	.db	%00100000
	.db	%01110000
	.db	%00100000
	.db	%00000000

highscore:
	.dw	0

title:
 

.db	$10,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$10,$00,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF
 .db $FF,$FF,$FE,$00,$00,$00,$00,$00,$06,$00,$00,$0F
 .db $FF,$FF,$90,$00,$80,$3F,$FF,$FF,$FF,$FF,$FF,$FF
 .db $FF,$FF,$90,$00,$80,$3F,$FF,$FF,$FF,$FF,$FF,$FF
 .db $FF,$FF,$90,$04,$80,$3F,$FF,$FF,$FF,$FF,$FF,$FF
 .db $C3,$FF,$90,$04,$80,$3F,$FF,$FF,$F3,$FF,$FF,$FF
 .db $01,$FD,$90,$07,$FF,$FF,$FF,$CF,$C1,$FF,$C1,$FE
 .db $19,$F9,$90,$05,$FF,$FF,$FF,$0F,$87,$9F,$00,$3C
 .db $79,$FB,$90,$05,$FF,$FF,$FC,$3C,$0F,$8F,$1E,$3C
 .db $79,$FB,$90,$05,$FF,$FF,$E0,$7C,$1E,$0F,$1F,$1C
 .db $E1,$F3,$90,$05,$FF,$FF,$80,$FC,$3E,$0F,$1F,$9C
 .db $C3,$E3,$90,$05,$FF,$FF,$81,$F8,$7C,$47,$0F,$9C
 .db $7F,$C7,$90,$05,$FF,$FF,$87,$F0,$FC,$E7,$8F,$9E
 .db $3F,$07,$90,$05,$FC,$3F,$0F,$F0,$FC,$E3,$8F,$9E
 .db $00,$0F,$90,$05,$F0,$0F,$1F,$F1,$FC,$F3,$CF,$9F
 .db $00,$7F,$90,$05,$E1,$8F,$0F,$F1,$FC,$F3,$C7,$1F
 .db $83,$FF,$90,$05,$C3,$CF,$00,$71,$FC,$E3,$C4,$1F
 .db $FF,$FF,$90,$05,$C7,$CF,$00,$31,$CC,$03,$C0,$3F
 .db $FF,$FF,$90,$05,$C7,$CF,$FC,$10,$9E,$03,$E1,$FF
 .db $FF,$FF,$90,$05,$C7,$8F,$FE,$18,$0F,$F3,$E7,$FF
 .db $FF,$FF,$90,$05,$C2,$1F,$FF,$1C,$1F,$F3,$C7,$FF
 .db $FF,$FF,$90,$05,$C0,$3F,$F7,$1F,$FF,$F3,$C7,$FF
 .db $FF,$FF,$90,$05,$E0,$7E,$60,$1F,$FF,$E7,$C7,$FF
 .db $FF,$FF,$90,$05,$E0,$FC,$70,$1F,$FF,$C7,$87,$FF
 .db $FF,$FF,$90,$05,$F0,$60,$60,$3F,$FF,$DF,$8F,$FF
 .db $FF,$FF,$90,$05,$F0,$00,$FF,$FF,$FF,$FF,$1F,$FF
 .db $FF,$FF,$90,$05,$FC,$03,$FF,$FF,$FF,$FF,$3F,$FF
 .db $80,$00,$90,$05,$FF,$FF,$FF,$FF,$FF,$FF,$FC,$75
 .db $FF,$FF,$90,$05,$FF,$FF,$FF,$FF,$FF,$FF,$FD,$75
 .db $80,$00,$90,$05,$FF,$FF,$FF,$FE,$00,$1F,$FD,$75
 .db $80,$00,$90,$05,$FF,$FF,$02,$00,$00,$03,$FD,$75
 .db $80,$00,$10,$05,$FF,$FF,$FF,$FF,$FF,$FF,$FC,$55
 .db $80,$00,$10,$05,$FF,$FE,$02,$00,$00,$00,$0F,$FF
 .db $FF,$FF,$FC,$05,$FF,$FC,$02,$00,$00,$00,$00,$00
 .db $00,$00,$10,$0F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
 .db $FF,$00,$10,$04,$80,$00,$02,$00,$00,$00,$00,$00
 .db $00,$00,$10,$04,$A0,$00,$02,$90,$00,$00,$00,$00
 .db $00,$00,$10,$04,$A0,$00,$20,$91,$00,$00,$00,$00
 .db $00,$00,$10,$00,$BA,$8E,$EE,$F7,$3F,$FF,$FF,$FF
 .db $FF,$FF,$FC,$00,$AA,$8A,$A8,$95,$00,$00,$00,$00
 .db $00,$00,$00,$00,$BB,$8E,$EE,$97,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$88,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$88

txt_score:
	.db	"Score",0

txt_time:
	.db	"Time",0

txt_balls:
	.db	"Balls",0

txt_lives:
	.db	"Lives",0

txt_highscore:
	.db	"Highscore :  ",0

txt_new_highscore:
	.db	"New highscore !",0

txt_blank:
	.db	"   ",0

ball_sprite1:
	ld	a,(hl)
	ld	e,a
	dec	hl
	ld	a,(hl)
ball_sprite:
cursor_sprite = $+3
	ld	bc,ball
	;ld	d,5
;  Z80  Sprite83  Movax     -----------**  modified by pacHa (you can now choose the length of the sprite)
; Sprite xor routine v1.0
; Coded by Hannes Edfeldt in 1997

; This routine uses xor to draw the sprite, therefore
; you can erase the sprite by just drawing it again at
; the same x and y coordinates. See xordemo.z80 for an
; example of how to use this routine.

; Feel free to use this routine in your own productions

; as long as you give me some credit.

; This file should of course be viewed in a DOS texteditor ;)

; Hannes Edfeldt -+- movax@algonet.se -+- http://www.algonet.se/~movax

; SPRXOR 
; Xor 8x8 sprite  a=x, e=y, bc=sprite address, d=length of the sprite
SPRXOR:
        push    bc              ; Save sprite address
	;push	af
	;ld	a,d
	;ld	(modif),a
	;ld	(modif1),a
	;pop	af
;====   Calculate the address in graphbuf   ====
        ld      hl,0            ; Do y*12
        ld      d,0
        add     hl,de
        add     hl,de
        add     hl,de
        add     hl,hl
        add     hl,hl
        ld      d,0             ; Do x/8
        ld      e,a
        srl     e
        srl     e
        srl     e
        add     hl,de
        ld      de,GRAPH_MEM
        add     hl,de           ; Add address to graphbuf
        ;ld      b,00000111b     ; Get the remainder of x/8
        ;and     b
	and	%00000111
        ;cp      0              ; Is this sprite aligned to 8*n,y?
        jr      z,ALIGN
;====   Non aligned sprite blit starts here   ====
        pop     ix              ; ix->sprite
        ld      d,a             ; d=how many bits to shift each line
modif = $+1
        ld      e,5             ; Line loop
LILOP:  ld      b,(ix+0)        ; Get sprite data
        ld      c,0             ; Shift loop
        push    de
SHLOP:  srl     b
        rr      c
        dec     d
        jp      nz,SHLOP
        pop     de
        ld      a,b             ; Write line to graphbuf
        xor     (hl)
        ld      (hl),a
        inc     hl
        ld      a,c
        xor     (hl)
        ld      (hl),a
        ld      bc,11           ; Calculate next line address
        add     hl,bc
        inc     ix              ; Inc spritepointer
        dec     e
        jr      nz,LILOP        ; Next line
        ret
;====   Aligned sprite blit starts here   ====
ALIGN:                          ; Blit an aligned sprite to graphbuf
        pop     de              ; de->sprite
modif1 = $+1
        ld      b,5
ALOP1:  ld      a,(de)
        xor     (hl)
        ld      (hl),a
        inc     de
        push    bc
        ld      bc,12
        add     hl,bc
        pop     bc
        djnz    ALOP1
DONE1:
        ret
; SPRXOR 

; Z80 Sprite83  movax
	

; ** GetPixel
; Input:   Coordinates (B, C)
; Returns: Z is set if pixel is off
;          Z is cleared if pixel is on
GetPixel:
  PUSH HL
  PUSH BC
FindPix:                        ; Same as FIND_PIXEL but maybe faster
  LD  A, B                      ; Save B (real X val)
  LD  B, 0
  LD  H, B
  LD  L, C
  ADD HL, HL
  ADD HL, BC
  ADD HL, HL
  ADD HL, HL
  LD  C, A
  SRL C
  SRL C
  SRL C
  ADD HL, BC
  LD  BC, GRAPH_MEM
  ADD HL, BC
  LD  B, %10000000
  AND %00000111
  JR  Z, GetPixDone
  LD  C, A
  LD  A, B
  LD  B, C
ShloopGetPix:
  RRA
  DJNZ ShloopGetPix
  LD  B, A
GetPixDone:
  LD  A, (HL)
  AND B
  POP BC
  POP HL
  RET

#ifdef TI83
DIRECT_KEY:
 ld a,$ff
 out ($01),a
 dec a
 out ($01),a
 in a,($01)
 ld d,a
 ld a,$bf
 out ($01),a
 in a,($01)
 or $0f
 xor d
 ret

hl_deci83:
 push de
 ld bc,$0504
 ld de,saferam5 + 5
 xor a
 ld (de),a
hl_deci83loop:
 call UNPACK_HL
 add a,$30
 dec de
 ld (de),a
 djnz hl_deci83loop
 ex de,hl
 pop de
 ld a,$30
hl_deci83loop2:
 cp (hl)
 jr nz,hl_deci83_
 inc hl
 dec c
 jr nz,hl_deci83loop2
hl_deci83_:
 ld a,$04
 sub c
 ret

PAUSE:
	call	_getk
	cp	G_ENTER
	jr	nz,PAUSE
	ret
#endif

.end
END